from microbit import *
import radio

# define address TOF
addr = 0x52

# Set the PWM of the servo
# (there might be a bug in the micro:bit as when
# I set the PWM frequencyx for the motors, this
# PWM is changed as well, so you'll see this line again)
pin0.set_analog_period(10)

# set new variable names to make ut readable
pin_step_l = pin2
pin_step_r = pin8
pin_dir_l = pin12
pin_dir_r = pin1
pin_servo = pin0


#define simple functions
def moveForward():
    # left
    pin_dir_l.write_digital(1)
    pin_step_l.set_analog_period(1)
    pin_step_l.write_analog(511)
    # right
    pin_dir_r.write_digital(1)
    pin_step_r.set_analog_period(1)
    pin_step_r.write_analog(511)

def moveLeft():
    # left
    pin_dir_l.write_digital(0)
    pin_step_l.set_analog_period(1)
    pin_step_l.write_analog(511)
    # right
    pin_dir_r.write_digital(1)
    pin_step_r.set_analog_period(1)
    pin_step_r.write_analog(511)

def moveRight():
    # left
    pin_dir_l.write_digital(1)
    pin_step_l.set_analog_period(1)
    pin_step_l.write_analog(511)
    # right
    pin_dir_r.write_digital(0)
    pin_step_r.set_analog_period(1)
    pin_step_r.write_analog(511)

def stop():
    pin_step_l.write_analog(0)
    pin_step_r.write_analog(0)


def getDistanceTof():
    # send something
    i2c.write(addr,b'0x00')
    # wait for reading to be ready
    sleep(1)
    # read
    data = i2c.read(0x52, 2)
    data= int.from_bytes(data, "big")
    print(str(data)+"mm")
    sleep(10)
    return data

def lookRight():
    pin_servo.set_analog_period(20)
    pin_servo.write_analog(37)
    sleep(900)
    pin_servo.write_analog(0)
    sleep(100)
def lookStraight():
    pin_servo.set_analog_period(20)
    pin_servo.write_analog(80)
    sleep(900)
    pin_servo.write_analog(0)
    sleep(100)
def lookLeft():
    pin_servo.set_analog_period(20)
    pin_servo.write_analog(122)
    sleep(900)
    pin_servo.write_analog(0)
    sleep(100)


standBy = True
lookStraight()
stop()

while True:
    if button_a.was_pressed():
        standBy = not(standBy)
        if standBy:
            stop()
        else:
            lookStraight()
            moveForward()

    if not(standBy):
        display.show(Image.HAPPY)
        distance = getDistanceTof()
        if distance < 60 :
            stop()
            display.show("?")
            lookLeft()
            distLeft = getDistanceTof()
            lookStraight()
            lookRight()
            distRight = getDistanceTof()
            lookStraight()

            betterSide = 0
            if distLeft>distRight:
                betterSide = 0
                maxDist = distLeft
            else:
                betterSide = 1
                maxDist = distRight

            if maxDist<=150 :
                standBy = True
                display.show(Image.SAD)
            else:
                if betterSide == 0:
                    display.show(Image.ARROW_E)
                    moveLeft()
                    sleep(1200)
                    moveForward()
                else:
                    display.show(Image.ARROW_W)
                    moveRight()
                    sleep(1200)
                    moveForward()